/*
 * Copyright 2013-2024, Seqera Labs
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package nextflow.cli

import com.beust.jcommander.Parameters

/**
 * Self-update command
 *
 * @author Paolo Di Tommaso <paolo.ditommaso@gmail.com>
 */
@Parameters(commandDescription = "Update nextflow runtime to the latest available version")
class CmdSelfUpdate extends CmdBase {
    @Override
    String getName() { 'self-update' }

    @Override
    void run() {
        // actually it's doing nothing, the update process is managed by the external launcher script
        // this class in only necessary to print the command line the usage output
    }
}
